﻿/**
 * 女帝戦記4 cutter
 *
 * 実データの単純連結形式
 * アーカイブヘッダはカットに際しては今一役に立たない
 *
 */

import std.stdio;
import std.string;
import std.stream;

uint get_dword(ubyte[] p_in)
{
  return (
      ((p_in[0] << 24) & 0xff000000) +
      ((p_in[1] << 16) & 0xff0000) +
      ((p_in[2] <<  8) & 0xff00) +
       (p_in[3]        & 0xff)
      );
}

ushort get_word(ubyte[] p_in)
{
    return (
        ((p_in[0] <<  8) & 0xff00) +
         (p_in[1]        & 0xff)
        );
}

void cutter(char[] name, ubyte[] input, ulong input_size)
{
  uint data_ofs;			// file size info offset
  uint data_size;			// file data size
  uint read_ofs = 0x00;
  int i;
  char fnamez[0x10] = '\0';

  writefln("Size  Offset Name");
  writefln("-------------------------");

  // header search
  for (;read_ofs < input_size; read_ofs++) {
    if (input[read_ofs  ] == 0x4c && input[read_ofs+1] == 0x7a &&
        input[read_ofs+2] == 0x73 && input[read_ofs+3] == 0x31) {
      break;
    }
  }
  data_ofs = read_ofs;
  read_ofs++;

  // split
  do {
      for (;read_ofs < input_size; read_ofs++) {
          if (input[read_ofs  ] == 0x4c && input[read_ofs+1] == 0x7a &&
              input[read_ofs+2] == 0x73 && input[read_ofs+3] == 0x31) {
              break;
          }
      }

      data_size = read_ofs - data_ofs;
      std.string.sformat(fnamez, "%s%02d%s", "BGM", i, ".ZMD");
      writefln("%5d 0x%04x %s", data_size, data_ofs, fnamez);

    if (data_size) {
      File outp = new File(fnamez, FileMode.OutNew);
      if (outp) {
        outp.writeExact(&input[data_ofs], data_size);
        delete outp;
      }
    }
    data_ofs = read_ofs;
    read_ofs++;
    i++;
  } while(input_size > read_ofs);

  writefln("-------------------------");
}

int main (char[][] args)
{
  try {
    auto input_size = std.file.getSize("ALL_ZMD.DAT");
    ubyte[] input = cast(ubyte[])std.file.read("ALL_ZMD.DAT");
    cutter("ALL_ZMD.DAT", input, input_size);
  } catch(Exception e) {
    writefln("catch %s", e.msg);
  }
  return 0;
}
